routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\HomeController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\MasterLoginController;
use App\Http\Controllers\Admin\MasterApplicationController;
use App\Http\Controllers\Admin\MasterProductController;
use App\Http\Controllers\Admin\LayoutHomeController;
use App\Http\Controllers\Admin\LayoutAboutController;
use App\Http\Controllers\Admin\LayoutManufacturingController;
use App\Http\Controllers\Admin\LayoutNewsController;
use App\Http\Controllers\Admin\LayoutContactController;
use App\Http\Controllers\Admin\NewsController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/
Route::controller(HomeController::class)->group(function () {
    Route::get('/', 'index')->name('home');
    Route::get('/about-us', 'aboutus')->name('aboutus');
    Route::get('/manufacturing', 'manufacturing')->name('manufacturing');
    Route::get('/product', 'product')->name('product');
    Route::get('/product/json', 'product_json')->name('productJson');
    Route::post('/product/foodmail', 'productFootmail')->name('product.foodmail');
    Route::post('/product/splytmail', 'productSplytmail')->name('product.splytmail');
    Route::prefix('/applications')->group(function(){
        Route::get('/aseptic-packaging', 'aseptic')->name('aseptic');
        Route::get('/paper-packaging', 'paper')->name('paper');
    });
    Route::prefix('/contact-us')->group(function(){
        Route::get('/', 'contact')->name('contact');
        Route::post('/store', 'contact_store')->name('contact.store');
    });
    Route::prefix('/news')->group(function(){
        Route::get('/', 'news')->name('news');
        Route::get('/{id}/{slug}', 'news_detail')->name('news.detail');
    });
});
Route::get('/panel', function(){ return redirect()->route('login'); });
Route::prefix('/admin')->group(function(){
    Route::get('/', [AuthController::class, 'login'])->name('login');
    Route::post('/', [AuthController::class, 'login_process'])->name('login.process');
});
Route::get('/logout', [AuthController::class, 'logout_process'])->name('logout');

Route::middleware('auth')->group(function(){
    Route::controller(DashboardController::class)->group(function(){
        Route::prefix('/dashboard')->group(function(){
            Route::get('/', 'index')->name('dashboard');
        });
    });
    Route::prefix('/master')->name('master.')->group(function(){
        Route::resource('/login', MasterLoginController::class);
        Route::post('/login/{id}', [MasterLoginController::class, 'update']);

        Route::resource('/application', MasterApplicationController::class);
        Route::resource('/product', MasterProductController::class);
    });
    Route::prefix('/layouts')->name('layout.')->group(function(){
        Route::resource('/home', LayoutHomeController::class);
        Route::resource('/about', LayoutAboutController::class);
        Route::resource('/manufacturing', LayoutManufacturingController::class);
        Route::resource('/news', LayoutNewsController::class);
        Route::resource('/contact', LayoutContactController::class);
    });
    Route::prefix('/admin')->group(function(){
        Route::resource('/news', NewsController::class);
        Route::post('/news/{id}', [NewsController::class, 'update'])->name('news.update');
        Route::post('/news-upload-image', [NewsController::class, 'upload_image'])->name('news.upload.image');
    });
});

app/Models/News.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class News extends Model
{
    use HasFactory;
    protected $table = 'news';
    protected $primaryKey = 'id';
    protected $fillable = [
        'title',
        'feature_image',
        'author',
        'content',
        'news_created',
        'read_post',
        'created_at',
        'updated_at',
    ];
}

app/Http/Controllers/Admin/NewsController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\News;
use DB, Storage;
class NewsController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $newsData = News::orderByDesc('id')->get();
        $data = [
            'news' => $newsData,
            'mod' => 'news',
            'page' => 'view_post',
        ];
        return view('pages.admin.news.index', compact(['data']));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $data = [
            'mod' => 'news',
            'page' => 'add_post',
        ];
        return view('pages.admin.news.create', compact(['data']));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        try {
            DB::beginTransaction();

            $tujuan_upload = public_path('assets/images/news/');
            $file = $request->file('feature_image');
            $fileName = time().'-'.$file->getClientOriginalName();
            $file->move($tujuan_upload, $fileName);

            $feature_image = url('assets/images/news/'.$fileName);

            $data = [
                'title' => $request->title,
                'feature_image' => $feature_image,
                'author' => auth()->user()->username,
                'content' => $request->content,
                'news_created' => now(),
            ];

            News::firstOrCreate($data);

            DB::commit();
            return redirect()->route('news.index')->with('success', 'Data saved successfully');

        } catch (\Throwable $th) {
            DB::rollback();
            return back()->with('error', $th->getMessage());
        }
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(string $id)
    {
        $newsData = News::find($id);
        $data = [
            'news' => $newsData,
            'mod' => 'news',
            'page' => 'view_post',
        ];
        return view('pages.admin.news.edit', compact(['data']));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        $newsData = News::find($id);
        try {
            DB::beginTransaction();
            if($request->feature_image){
                $tujuan_upload = public_path('assets/images/news/');
                $file = $request->file('feature_image');
                $fileName = time().'-'.$file->getClientOriginalName();
                $file->move($tujuan_upload, $fileName);

                $feature_image = url('assets/images/news/'.$fileName);
            } else {
                $feature_image = $newsData->feature_image;
            }

            $data = [
                'title' => $request->title,
                'feature_image' => $feature_image,
                'content' => $request->content,
            ];

            News::find($id)->update($data);

            DB::commit();
            return redirect()->route('news.index')->with('success', 'Data saved successfully');

        } catch (\Throwable $th) {
            DB::rollback();
            return back()->with('error', $th->getMessage());
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        $data = News::find($id)->delete();
        return response()->json(['message' => 'data deleted', 'data' => $data], 200);
    }

    public function upload_image(Request $request)
    {
        if ($request->hasFile('upload')) {
            $file = $request->file('upload');
            $fileName = time() . '.' . $file->getClientOriginalExtension();
            $filePath = 'assets/news/uploads/' . $fileName;

            // Simpan file ke storage/public/uploads
            Storage::put('public/' . $filePath, file_get_contents($file));

            $url = Storage::url($filePath);

            return response()->json([
                'url' => $url
            ]);
        }

        return response()->json(['error' => 'No file uploaded'], 400);
    }
}

resources/views/pages/admin/news/create.blade.php
@extends('pages.admin.theme.layout')
@section('title', 'News - Add Post')
@section('content')

<style>
    .ck-editor__editable_inline {
            min-height: 700px; /* Sesuaikan nilai ini untuk mengatur tinggi editor */
        }
</style>


{{-- <script src="{{ asset('assets-panel/ckeditor2/ckeditor.js') }}"></script> --}}
{{-- <script src="https://cdn.ckeditor.com/ckeditor5/39.0.0/classic/ckeditor.js"></script> --}}
<script src="{{ asset('assets/tinymce/js/tinymce/tinymce.min.js') }}"></script>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">View Post</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item">News</li>
              <li class="breadcrumb-item active">Add Post</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Main row -->
        <div class="row">
            @if(Session::has('success'))
                <div style="margin: 0 0 10px 10px;"><span class="badge success">{{ Session::get('success') }}</span></div>
            @endif
            @if(Session::has('error'))
                <div style="margin: 0 0 10px 10px;"><span class="badge danger">{{ Session::get('success') }}</span></div>
            @endif
          <!-- Left col -->
          <section class="col-lg-12 connectedSortable">
            <!-- Custom tabs (Charts with tabs)-->
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">
                  <i class="fas fa-images mr-1"></i>
                  View Post
                </h3>
                <div class="card-tools">
                  <button type="button" class="btn btn-tool" data-card-widget="collapse">
                    <i class="fas fa-plus"></i>
                  </button>
                </div>
              </div><!-- /.card-header -->
              <div class="card-body">
                <form action="{{ route('news.store') }}" method="post" enctype="multipart/form-data">
                    @csrf
          				<div class="form-group">
          					<label>Title :</label>
          					<input class="form-control" type="text" name="title" maxlength="150" value="" required>
          				</div>
          				<div class="form-group">
                      <label>Content :</label><br />
                      <small>
                        * cara untuk mengupload gambar :<br />
                        1. Jika gambar ada di penyimpanan lokal, silahkan copy gambar lalu tempelkan gambar di tempat yang sesuai.<br />
                        2. Jika gambar berada di link tertentu, silahkan klik menu insert -> image lalu isi field source dengan url gambar anda<br />
                    </small><br />
                      <textarea name="content" id="content" class="form-control"></textarea>
                  </div>
          				<div class="form-group">
          					<label>Featured Image :</label><br>
          					<img id="pic1" class="img-responsive" width="480" src="{{ asset('assets/images/upload.jpg') }}"><br />
          					<input type="file" name="feature_image" id="img1" required>
          				</div>
          				<div class="clearfix"></div>
          				<input type="submit" class="btn btn-warning" value="Simpan">
          			</form>
              </div><!-- /.card-body -->
            </div>


            <!-- /.card -->
          </section>


          <!-- /.Left col -->
        </div>
        <!-- /.row (main row) -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>

<script>
    tinymce.init({
        selector: 'textarea#content',
        plugins: 'image',
        toolbar: 'undo redo | blocks | bold italic | alignleft aligncentre alignright alignjustify | indent outdent | bullist numlist',
    });
  function refresh_pic(){
    var str="../assets/images/news/";
    var img=$('#img1').val();
    $("#pic1").attr("src", str + img);
    $('#img1').val(str + img);
  }
  $('#img1').change(function(event){
        const file = event.target.files[0];
        if (file) {
            const reader = new FileReader();
            reader.onload = function(e) {
                const previewImage = document.getElementById('pic1');
                previewImage.src = e.target.result;
            }
            reader.readAsDataURL(file);
        } else {
            const previewImage = document.getElementById('pic1');
            previewImage.src ="{{ asset('assets/images/upload.jpg') }}";
        }
    })

  function get_delete(id){
    $('#id').val(id);
    $('#myModal').modal('show');
  }

  $(document).ready(function(){

  });
</script>

@endsection

resources/views/pages/admin/news/edit.blade.php
@extends('pages.admin.theme.layout')
@section('title', 'News - Edit Post')
@section('content')

<style>
    .ck-editor__editable_inline {
            min-height: 700px; /* Sesuaikan nilai ini untuk mengatur tinggi editor */
        }
</style>


{{-- <script src="{{ asset('assets-panel/ckeditor2/ckeditor.js') }}"></script> --}}
{{-- <script src="https://cdn.ckeditor.com/ckeditor5/39.0.0/classic/ckeditor.js"></script> --}}
<script src="{{ asset('assets/tinymce/js/tinymce/tinymce.min.js') }}"></script>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">View Post</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item">News</li>
              <li class="breadcrumb-item active">Add Post</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Main row -->
        <div class="row">
            @if(Session::has('success'))
                <div style="margin: 0 0 10px 10px;"><span class="badge success">{{ Session::get('success') }}</span></div>
            @endif
            @if(Session::has('error'))
                <div style="margin: 0 0 10px 10px;"><span class="badge danger">{{ Session::get('success') }}</span></div>
            @endif
          <!-- Left col -->
          <section class="col-lg-12 connectedSortable">
            <!-- Custom tabs (Charts with tabs)-->
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">
                  <i class="fas fa-images mr-1"></i>
                  View Post
                </h3>
                <div class="card-tools">
                  <button type="button" class="btn btn-tool" data-card-widget="collapse">
                    <i class="fas fa-plus"></i>
                  </button>
                </div>
              </div><!-- /.card-header -->
              <div class="card-body">
                <form action="{{ route('news.update', $data['news']->id) }}" method="post" enctype="multipart/form-data">
                    @csrf
          				<div class="form-group">
          					<label>Title :</label>
          					<input class="form-control" type="text" name="title" maxlength="150" value="{{ $data['news']->title }}" required>
          				</div>
          				<div class="form-group">
                      <label>Content :</label><br />
                      <small>
                        * cara untuk mengupload gambar :<br />
                        1. Jika gambar ada di penyimpanan lokal, silahkan copy gambar lalu tempelkan gambar di tempat yang sesuai.<br />
                        2. Jika gambar berada di link tertentu, silahkan klik menu insert -> image lalu isi field source dengan url gambar anda<br />
                    </small><br />
                      <textarea name="content" id="content" class="form-control">{{ $data['news']->content }}</textarea>
                  </div>
          				<div class="form-group">
          					<label>Featured Image :</label><br>
          					<img id="pic1" class="img-responsive" width="480" src="{{ $data['news']->feature_image }}"><br /><br />
          					<input type="file" name="feature_image" id="img1">
          				</div>
          				<div class="clearfix"></div>
          				<input type="submit" class="btn btn-warning" value="Simpan">
          			</form>
              </div><!-- /.card-body -->
            </div>


            <!-- /.card -->
          </section>


          <!-- /.Left col -->
        </div>
        <!-- /.row (main row) -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>

<script>
    tinymce.init({
        selector: 'textarea#content',
        plugins: 'image',
        toolbar: 'undo redo | blocks | bold italic | alignleft aligncentre alignright alignjustify | indent outdent | bullist numlist',
    });
  function refresh_pic(){
    var str="../assets/images/news/";
    var img=$('#img1').val();
    $("#pic1").attr("src", str + img);
    $('#img1').val(str + img);
  }
    $('#img1').change(function(event){
        const file = event.target.files[0];
        if (file) {
            const reader = new FileReader();
            reader.onload = function(e) {
                const previewImage = document.getElementById('pic1');
                previewImage.src = e.target.result;
            }
            reader.readAsDataURL(file);
        } else {
            const previewImage = document.getElementById('pic1');
            previewImage.src ="{{ $data['news']->feature_image }}";
        }
    })

  function get_delete(id){
    $('#id').val(id);
    $('#myModal').modal('show');
  }

  $(document).ready(function(){

  });

</script>

@endsection

resources/views/pages/admin/news/index.blade.php
@extends('pages.admin.theme.layout')
@section('title', 'News - Add Post')
@section('content')


  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">View Post</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item">News</li>
              <li class="breadcrumb-item active">View Post</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Main row -->
        <div class="row">
          <?php
          if (isset($pesan)){
            $warna=($warna=="green" ? "success" : "failed");
            echo '<div style="margin: 0 0 10px 10px;"><span class="badge ' .$warna. '">' .$pesan. '</span></div>';
          }
          ?>
          <!-- Left col -->
          <section class="col-lg-12 connectedSortable">
            <!-- Custom tabs (Charts with tabs)-->
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">
                  <i class="fas fa-images mr-1"></i>
                  View Post
                </h3>
                <div class="card-tools">
                  <button type="button" class="btn btn-tool" data-card-widget="collapse">
                    <i class="fas fa-plus"></i>
                  </button>
                </div>
              </div><!-- /.card-header -->
              <div class="card-body">
                <table id="table2" class="table table-bordered table-striped">
          				<thead>
          					<tr>
          						<th>#</th>
          						<th>Title</th>
          						<th>Author</th>
          						<th>Date</th>
          						<th>Reads</th>
          						<th></th>
          					</tr>
          				</thead>
          				<tbody>
                            @foreach ($data['news'] as $index => $nw )
                                <tr>
                                    <td align="center"><a href="{{ route('news.edit', $nw->id) }}"><div style="min-width:70px">{{ $index + 1 }}</div></a></td>
                                    <td><a href="{{ route('news.edit', $nw->id) }}"><div style="min-width:70px">{{ $nw->title }}</div></a></td>
                                    <td><a href="{{ route('news.edit', $nw->id) }}"><div style="min-width:70px">{{ $nw->author }}</div></a></td>
                                    <td><a href="{{ route('news.edit', $nw->id) }}"><div style="min-width:70px">{{ date('F d, Y | H:i', strtotime($nw->news_created)) }}</div></a></td>
                                    <td align="center"><a href="{{ route('news.edit', $nw->id) }}"><div style="min-width:70px">{{ $nw->read_post }}</div></a></td>
                                    <td><a href="javascript:;" onclick="get_delete({{ $nw->id }})" class="btn btn-primary btn-xs" title="DELETE"><i class="fa fa-trash"></i> Hapus</a></td>
                                </tr>
                            @endforeach
          				</tbody>
          			</table>
              </div><!-- /.card-body -->
            </div>


            <!-- /.card -->
          </section>


          <!-- /.Left col -->
        </div>
        <!-- /.row (main row) -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>

  <div class="modal fade" id="myModal">
    <div class="modal-dialog">
      <div class="modal-content bg-default">
        <div class="modal-header">
          <h4 class="modal-title">Delete this Content ?</h4>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Are you sure wanna delete this content ?</p>
          <form method="post">
            <input type="hidden" name="del_content" value="true" />
            <input type="hidden" name="id" id="id" value="" />
        </div>
        <div class="modal-footer justify-content-between">
          <button type="button" class="btn btn-outline-light" data-dismiss="modal"><i class="fa fa-times"></i> No</button>
          <input type="button" id="submit-delete" class="btn btn-danger" value="Submit">
        </form>
        </div>
      </div>
    </div>
  </div>

<script>
    let token   = $("meta[name='csrf-token']").attr("content");
  function get_delete(id){
    $('#id').val(id);
    $('#myModal').modal('show');
  }

  $('#submit-delete').click(function(){
        $('#submit-delete').val('loading ...')
        let id = $('#myModal').find('input[name=id]').val()
        $.ajax({
            url: '/admin/news/'+id,
            type: 'DELETE',
            cache: false,
            data: {
                "_token": token
            },
            success:function(response){
                window.location.reload()
                $('#submit-delete').val('Submit')
            },
            error: function(error){
                $('#submit-delete').val('Submit')
                console.error(error)
            }
        })
    })
</script>

@endsection